# -*- coding: utf-8 -*-
"""
Created on Sat Mar  6 14:56:46 2021

@author: rev7199
"""
import numpy as np
from nltk.corpus import stopwords
from tensorflow.keras.preprocessing.text import Tokenizer
import pickle
from tensorflow.keras.preprocessing import sequence
import itertools
import tensorflow as tf 

LABELS = {
    0: "joy",
    1: "sadness",
    2: "anger",
    3: "fear",
    4: "love",
    5: "surprise"
}


def pre_processing_input(user_input: str) -> np.array:
    # Removing stop words
    print("USER INPUT: ", user_input)
    words_list = user_input.split()
    filtered_words = [word for word in words_list if word not in stopwords.words('english')]

    with open("text_without_stop_words.dat", "rb") as text:
       text_without_stop_words  = pickle.load(text)

    tok2 = Tokenizer()
    tok2.fit_on_texts(text_without_stop_words)  # Tokenize all text
    filtered_words = tok2.texts_to_sequences(filtered_words)
    
    filtered_words = list(itertools.chain(*filtered_words))
    array = np.array(filtered_words).reshape((1, -1))
    
    # Normalize sequences to same size
    vec_len = 50
    model_input = sequence.pad_sequences(array, maxlen=vec_len)
        
    return model_input


def make_prediction(model_input: np.array):
    model = tf.keras.models.load_model('my_model.h5')
    prediction = model.predict(model_input)
    print("RESULT: ", prediction)
    
    highest_probab = np.amax(prediction)
    
    for index, probab in enumerate(prediction[0]):
        if probab == highest_probab:
            res_label = index
    
    return (LABELS[res_label], round(highest_probab * 100, 2))


def get_prediction(user_input: str) -> tuple:
    return make_prediction(pre_processing_input(user_input))



